unit UFPuntuales;

interface
uses
  SysUtils, Variants, Classes, math, UApoyo;

  procedure FP_Negativo  ( Ma : Mat3d; var Mb : Mat3d);
  procedure FP_Grises    ( Ma : Mat3d; var Mb : Mat3d);
  procedure FP_Logaritmo ( Ma : Mat3d; var Mb : Mat3d);
  procedure FP_Gamma     ( Ma : Mat3d; var Mb : Mat3d; gg: single);

implementation

  // Negativo
  procedure FP_Negativo( Ma : Mat3d; var Mb : Mat3d);
  var
    x,y,can : integer;

  begin
    Mat2Mat(Ma,Mb);

    for can := 0 to 2 do if Kanales[can]
      then // aplica el filtro
        for y := _y1 to _y2 - 1 do
          for x := _x1 to _x2 - 1 do
          // ---
            Mb.dat[x][y][can] := _Lamb - Ma.dat[x][y][can];
          // ---

  end;

  // Grises
  procedure FP_Grises( Ma : Mat3d; var Mb : Mat3d);
  var
    nx,ny, x,y,can : integer;
    suma           : single;
  begin
    nx := Ma.nc;
    ny := Ma.nr;
    SetMat(Mb,nx,ny,3);

    for y := _y1 to _y2 - 1 do
      for x := _x1 to _x2 - 1 do begin
        // ---
        suma := 0.0;
        for can := 0 to 2 do suma := suma + Ma.dat[x][y][can];
        suma := suma/3;
        for can := 0 to 2 do Mb.dat[x][y][can] := suma;
        // ---
      end;
  end;

  // LOgaritmo o Rango Dinamico
  procedure FP_Logaritmo ( Ma : Mat3d; var Mb : Mat3d);
  var
    x,y,can   : integer;
    fact      : single;
  begin
    Mat2Mat(Ma,Mb);

    fact := _Lamb/(ln(_Lamb+1));

    for can := 0 to 2 do if Kanales[can]
      then
        for y := _y1 to _y2 - 1 do
          for x := _x1 to _x2 - 1 do
            // ---
              Mb.dat[x][y][can] :=  fact*ln(Ma.dat[x][y][can]+1)
            // ---
  end;

  // Filtro o Correccion Gamma
  procedure FP_Gamma     ( Ma : Mat3d; var Mb : Mat3d; gg: single);
  var
    x,y,can  : integer;
  begin
    Mat2Mat(Ma,Mb);

    for y := _y1 to _y2 - 1 do
      for x := _x1 to _x2 - 1 do begin
        // ---
        for can := 0 to 2 do
          Mb.dat[x][y][can] :=  _Lamb*power(Ma.dat[x][y][can]/_Lamb,gg);
        // ---
      end;
  end;
end.
